#include "DxLib.h"

int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow )
{
	ChangeWindowMode( TRUE ) ;

	SetBackgroundColor( 128,128,128 ) ;
	SetGraphMode( 640, 480, 32 ) ;

	if( DxLib_Init() == -1 )
	{
		return -1 ;
	}

	int vshandle = LoadVertexShader( "VertexTextureTestVS.vso" ) ;
	int pshandle = LoadPixelShader(  "VertexTextureTestPS.pso" ) ;
	int GrHandle = LoadGraph( "Tex1.bmp" ) ;

	SetDrawScreen( DX_SCREEN_BACK ) ;

	SetUseVertexShader( vshandle ) ;
	SetUsePixelShader( pshandle ) ;
	SetUseTextureToShader( 0, GrHandle ) ;

	VERTEX3DSHADER Vert[ 6 ] = { 0.0f } ;
	
	Vert[ 0 ].pos = VGet(   0.0f, 128.0f, 0.0f ) ;
	Vert[ 0 ].u   = 0.0f ;
	Vert[ 0 ].v   = 0.0f ;

	Vert[ 1 ].pos = VGet( 128.0f, 128.0f, 0.0f ) ;
	Vert[ 1 ].u   = 1.0f ;
	Vert[ 1 ].v   = 0.0f ;

	Vert[ 2 ].pos = VGet(   0.0f,   0.0f, 0.0f ) ;
	Vert[ 2 ].u   = 0.0f ;
	Vert[ 2 ].v   = 1.0f ;

	Vert[ 3 ].pos = VGet( 128.0f,   0.0f, 0.0f ) ;
	Vert[ 3 ].u   = 1.0f ;
	Vert[ 3 ].v   = 1.0f ;

	Vert[ 4 ] = Vert[ 2 ];
	Vert[ 5 ] = Vert[ 1 ];
	
	DrawPolygon3DToShader( Vert, 2 ) ;

	ScreenFlip() ;

	WaitKey() ;

	DxLib_End() ;				// cwCugp̏I

	return 0 ;					// \tg̏I
}
