// {p[^
struct DX_D3D11_VS_CONST_BUFFER_BASE
{
	float4		AntiViewportMatrix[ 4 ] ;	// A`r[|[gs
	float4		ProjectionMatrix[ 4 ] ;		// r[@@vWFNVs
	float4		ViewMatrix[ 3 ] ;		// [h@@r[s
	float4		LocalWorldMatrix[ 3 ] ;		// [J@@[hs

	float4		ToonOutLineSize ;		// gD[̗֊s̑傫
	float		DiffuseSource ;			// fBt[YJ[( 0.0f:}eA  1.0f:_ )
	float		SpecularSource ;		// XyLJ[(   0.0f:}eA  1.0f:_ )
	float		MulSpecularColor ;		// XyLJ[lɏZl( XyLŎgp )
	float		Padding ;
} ;

// {p[^
cbuffer cbD3D11_CONST_BUFFER_VS_BASE : register( b1 )
{
	DX_D3D11_VS_CONST_BUFFER_BASE	g_Base ;
} ;

// _VF[_[̓
struct VS_INPUT
{
	float3 pos             : POSITION0 ;		// W( [J )
	float4 spos            : POSITION1 ;		// \W
	float3 norm            : NORMAL0 ;			// @( [J )
	float3 tan             : TANGENT0 ;			// ڐ( [J )
	float3 binorm          : BINORMAL0 ;		// ]@( [J )
	float4 dif             : COLOR0 ;			// fBt[YJ[
	float4 spc             : COLOR1 ;			// XyLJ[
	float2 texCoords0      : TEXCOORD0 ;		// eNX`W
	float2 texCoords1      : TEXCOORD1 ;		// TueNX`W
} ;

// _VF[_[̏o
struct VS_OUTPUT
{
	float4 pos         : SV_POSITION ;	// W( vWFNV )
	float4 color       : COLOR0 ;		// F
} ;

Texture2D    g_SrcTexture       : register( t0 ) ;

VS_OUTPUT main( VS_INPUT VSInput )
{
	VS_OUTPUT VSOutput ;
	float4 lLocalPosition ;
	float4 lWorldPosition ;
	float4 lViewPosition ;
	float4 TexColor ;
	int3 TexPosition ;

	// _Wϊ ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++( Jn )

	// [JW̃Zbg
	lLocalPosition.xyz = VSInput.pos ;
	lLocalPosition.w = 1.0f ;

	// WvZ( [Jr[vWFNV )
	lWorldPosition.x = dot( lLocalPosition, g_Base.LocalWorldMatrix[ 0 ] ) ;
	lWorldPosition.y = dot( lLocalPosition, g_Base.LocalWorldMatrix[ 1 ] ) ;
	lWorldPosition.z = dot( lLocalPosition, g_Base.LocalWorldMatrix[ 2 ] ) ;
	lWorldPosition.w = 1.0f ;

	lViewPosition.x = dot( lWorldPosition, g_Base.ViewMatrix[ 0 ] ) ;
	lViewPosition.y = dot( lWorldPosition, g_Base.ViewMatrix[ 1 ] ) ;
	lViewPosition.z = dot( lWorldPosition, g_Base.ViewMatrix[ 2 ] ) ;
	lViewPosition.w = 1.0f ;

	VSOutput.pos.x = dot( lViewPosition, g_Base.ProjectionMatrix[ 0 ] ) ;
	VSOutput.pos.y = dot( lViewPosition, g_Base.ProjectionMatrix[ 1 ] ) ;
	VSOutput.pos.z = dot( lViewPosition, g_Base.ProjectionMatrix[ 2 ] ) ;
	VSOutput.pos.w = dot( lViewPosition, g_Base.ProjectionMatrix[ 3 ] ) ;

	// _Wϊ ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++( I )

	// eNX`J[Zbg
	TexPosition.x = ( int )( VSInput.texCoords0.x * 127.0f ) ;
	TexPosition.y = ( int )( VSInput.texCoords0.y * 127.0f ) ;
	TexPosition.z = 0 ;
	TexColor = g_SrcTexture.Load( TexPosition ) ;

	// p[^Zbg
	VSOutput.color = TexColor ;
	
	return VSOutput ;
}
